Anonymous | Login
Project:
RSS
  
News | My View | View Issues | Roadmap | Summary

View Issue DetailsJump to Notes ] Issue History ] Print ]
ID
0041503
TypeCategorySeverityReproducibilityDate SubmittedLast Update
defect[Openbravo ERP] Y. DBSourceManagerminoralways2019-07-31 12:022019-08-22 14:45
Reportermauricio_peccoriniView Statuspublic 
Assigned Tomauricio_peccorini 
PrioritylowResolutionfixedFixed in Version3.0PR19Q4
StatusclosedFix in branchFixed in SCM revision79fd9b1e2012
ProjectionnoneETAnoneTarget Version
OSAnyDatabaseOracleJava version
OS VersionDatabase versionAnt version
Product VersionSCM revision 
Review Assigned Toalostale
Web browser
ModulesCore
Regression level
Regression date
Regression introduced in release
Regression introduced by commit
Triggers an Emergency PackNo
Summary

0041503: DBSM doesn't handle not null BLOB columns correctly in Oracle

DescriptionOracle does not support changing the data type of a LOB column. As a result, the MODIFY COLUMN of an ALTER TABLE statement cannot include the data type when using one of the large object types.

During create.database DBSM issues statements to change the NULL or NOT NULL attribute of columns. When dealing with LOB columns it should not specify the data type. For example:
  ALTER TABLE OBSCHED_CALENDARS MODIFY CALENDAR BLOB NOT NULL
should be changed to:
  ALTER TABLE OBSCHED_CALENDARS MODIFY CALENDAR NOT NULL

This issue was already reported but it was only fixed for NOT NULL CLOB columns in: https://issues.openbravo.com/print_bug_page.php?bug_id=16713 [^]

The same solution should be applied for BLOB and NCLOB data types and for NULL columns.
Steps To Reproduce1. Add a BLOB column to a database table
2. Export the database
3. Execute create.database
Proposed SolutionModify the SqlBuilder to properly handle the different types of Large Object data types.

A proposed patch is included.
TagsNo tags attached.
Attached Filespatch file icon SqlBuilder.patch [^] (3,215 bytes) 2019-07-31 12:13 [Show Content]

- Relationships Relation Graph ] Dependency Graph ]
blocks feature request 0041484 closedcberner make job scheduling clusterizable 

-  Notes
(0113866)
hgbot (developer)
2019-08-07 10:49

Repository: erp/devel/pi
Changeset: 3c24ffd67ed161aff288655faee0517f5fe96e2c
Author: Mauricio Peccorini <mauricio.peccorini <at> openbravo.com>
Date: Wed Aug 07 10:48:18 2019 +0200
URL: http://code.openbravo.com/erp/devel/pi/rev/3c24ffd67ed161aff288655faee0517f5fe96e2c [^]

fixed bug 41503: ORA cannot create DB with mandatory BLOB column

  When creating DB mandatory columns are first created as nullable to later be
  updated to not nullable. In case of *LOB objects in oracle this step was not
  correctly managed.

---
M src-db/database/lib/dbsourcemanager.jar
---
(0113867)
hgbot (developer)
2019-08-07 10:50

Repository: erp/devel/dbsm-main
Changeset: 5788401bb2075e8760a666ef4292eed130dc6939
Author: Mauricio Peccorini <mauricio.peccorini <at> openbravo.com>
Date: Fri Aug 02 14:06:11 2019 +0200
URL: http://code.openbravo.com/erp/devel/dbsm-main/rev/5788401bb2075e8760a666ef4292eed130dc6939 [^]

related to issue 41503: added test case

---
M src-test/src/org/openbravo/dbsm/test/model/ModelSuite.java
A src-test/model/largeObjects/BLOB_TABLE_NOREQ.xml
A src-test/model/largeObjects/BLOB_TABLE_REQ.xml
A src-test/src/org/openbravo/dbsm/test/model/LargeObjects.java
---
(0113868)
hgbot (developer)
2019-08-07 10:50

Repository: erp/devel/dbsm-main
Changeset: 79fd9b1e2012f7ca9d0735b1411d393d682b6828
Author: Mauricio Peccorini <mauricio.peccorini <at> openbravo.com>
Date: Fri Aug 02 14:08:13 2019 +0200
URL: http://code.openbravo.com/erp/devel/dbsm-main/rev/79fd9b1e2012f7ca9d0735b1411d393d682b6828 [^]

fixed bug 41503: ORA cannot create DB with mandatory BLOB column

  When creating DB mandatory columns are first created as nullable to later be
  updated to not nullable. In case of *LOB objects in oracle this step was not
  correctly managed.

---
M src/org/apache/ddlutils/platform/SqlBuilder.java
---
(0113869)
hgbot (developer)
2019-08-07 10:50

Repository: erp/devel/dbsm-main
Changeset: c69a2dce04a47271ee418863b14c2fbdbf23ba44
Author: Asier Lostalé <asier.lostale <at> openbravo.com>
Date: Fri Aug 02 14:11:25 2019 +0200
URL: http://code.openbravo.com/erp/devel/dbsm-main/rev/c69a2dce04a47271ee418863b14c2fbdbf23ba44 [^]

related to issue 41503: removed some duplicity

---
M src/org/apache/ddlutils/platform/SqlBuilder.java
---
(0113870)
hgbot (developer)
2019-08-07 10:50

Repository: erp/devel/dbsm-main
Changeset: ec3c17db18fcd7bf8f6c4f7557c378046594bc22
Author: Asier Lostalé <asier.lostale <at> openbravo.com>
Date: Fri Aug 02 14:21:36 2019 +0200
URL: http://code.openbravo.com/erp/devel/dbsm-main/rev/ec3c17db18fcd7bf8f6c4f7557c378046594bc22 [^]

related to issue 41503: adds more test cases

---
M src-test/src/org/openbravo/dbsm/test/model/LargeObjects.java
---
(0113920)
alostale (developer)
2019-08-09 09:00

reviewed
(0114212)
hudsonbot (developer)
2019-08-22 14:45

A changeset related to this issue has been promoted main and to the
Central Repository, after passing a series of tests.

Promotion changeset: https://code.openbravo.com/erp/devel/main/rev/ad3efd3bd07c [^]
Maturity status: Test

- Issue History
Date Modified Username Field Change
2019-07-31 12:02 mauricio_peccorini New Issue
2019-07-31 12:02 mauricio_peccorini Assigned To => platform
2019-07-31 12:02 mauricio_peccorini File Added: SqlBuilder.patch
2019-07-31 12:02 mauricio_peccorini Modules => Core
2019-07-31 12:02 mauricio_peccorini Triggers an Emergency Pack => No
2019-07-31 12:03 mauricio_peccorini Relationship added blocks 0041484
2019-07-31 12:13 mauricio_peccorini File Deleted: SqlBuilder.patch
2019-07-31 12:13 mauricio_peccorini File Added: SqlBuilder.patch
2019-08-02 14:06 alostale Assigned To platform => mauricio_peccorini
2019-08-02 14:06 alostale Review Assigned To => alostale
2019-08-07 10:49 hgbot Checkin
2019-08-07 10:49 hgbot Note Added: 0113866
2019-08-07 10:49 hgbot Status new => resolved
2019-08-07 10:49 hgbot Resolution open => fixed
2019-08-07 10:49 hgbot Fixed in SCM revision => http://code.openbravo.com/erp/devel/pi/rev/3c24ffd67ed161aff288655faee0517f5fe96e2c [^]
2019-08-07 10:50 hgbot Checkin
2019-08-07 10:50 hgbot Note Added: 0113867
2019-08-07 10:50 hgbot Checkin
2019-08-07 10:50 hgbot Note Added: 0113868
2019-08-07 10:50 hgbot Fixed in SCM revision http://code.openbravo.com/erp/devel/pi/rev/3c24ffd67ed161aff288655faee0517f5fe96e2c [^] => http://code.openbravo.com/erp/devel/dbsm-main/rev/79fd9b1e2012f7ca9d0735b1411d393d682b6828 [^]
2019-08-07 10:50 hgbot Checkin
2019-08-07 10:50 hgbot Note Added: 0113869
2019-08-07 10:50 hgbot Checkin
2019-08-07 10:50 hgbot Note Added: 0113870
2019-08-09 09:00 alostale Note Added: 0113920
2019-08-09 09:00 alostale Status resolved => closed
2019-08-09 09:00 alostale Fixed in Version => 3.0PR19Q4
2019-08-22 14:45 hudsonbot Checkin
2019-08-22 14:45 hudsonbot Note Added: 0114212


Copyright © 2000 - 2009 MantisBT Group
Powered by Mantis Bugtracker